﻿using System;
using System.Security.Cryptography;
using System.Text;

/// <summary>
/// Полезные тулзы для работы веб-приложения
/// </summary>
public static class Tools
{
    /// <summary>
    /// Рандомизатор
    /// </summary>
    public static Random Random = new Random();

    /// <summary>
    /// Рандомная строка из маленьких букв латинского алфавита
    /// </summary>
    /// <param name="length">Длина строки</param>
    public static string RandomString(int length)
    {
        StringBuilder str = new StringBuilder(length);
        for (int i = 0; i < length; ++i)
            str.Append((char)Random.Next('a', 'z' + 1));
        return str.ToString();
    }

    /// <summary>
    /// Получает MD5-хеш строки
    /// </summary>
    /// <param name="input">Входная строка</param>
    public static string GetMd5Hash(string input)
    {
        StringBuilder result = new StringBuilder();
        foreach (byte x in new MD5CryptoServiceProvider()
            .ComputeHash(Encoding.UTF8.GetBytes(input)))
            result.Append(x.ToString("x2"));
        return result.ToString();
    }

    /// <summary>
    /// Генерирует рандомный ID в виде MD5-хеша
    /// </summary>
    public static string GenerateID()
    {
        const int keyLength = 15; // Длина рандомного ключа
        return GetMd5Hash(RandomString(keyLength) + Environment.TickCount);
    }
}