﻿<%@ WebHandler Language="C#" Class="SocketHandler" %>

using System.Web;
using System.Net.WebSockets;
using System.Threading.Tasks;
using System.Collections.Concurrent;

public class SocketHandler : IHttpHandler
{
    /// <summary>
    /// Стандартный метод для Handler
    /// </summary>
    /// <param name="context">Контекст запроса</param>
    public void ProcessRequest(HttpContext context)
    {
        // Если запрос является запросом веб сокета.
        if (context.IsWebSocketRequest)
        {
            context.AcceptWebSocketRequest(WebSocketRequest);
        }
    }

    /// <summary>
    /// Обрабатывает пришедший сокет
    /// </summary>
    /// <param name="context">Контекст запроса</param>
    async Task WebSocketRequest(WebSocketContext context)
    {
        // Получим веб-сокет клиента из контекста запроса.
        var socket = context.WebSocket;
        // ID игрока берется рандомным образом.
        string id = Tools.GenerateID();
        // Пытемся войти в режим записи
        try
        {
            // Попытаемся запустить задачу о добавлении игрока в коллекцию.
            Global.Players.TryAdd(id, new Player(socket, id));
            // Ставим игрока на прослушивание
        }
        catch
        {
            // TODO: Что-то пошло не так...
        }
        try
        {
            await Global.Players[id].ReceiveData();
            // После того как перестали принимать соединение от игрока - очистим его объекты.
            if (Global.Players.ContainsKey(id))
            {
                Player.DispoceFrom(id);
            }
        }
        catch { }
    }

    /// <summary>
    /// Возвращает значение, указывающее, может ли другой запрос использовать IHttpHandler экземпляра.
    /// </summary>
    public bool IsReusable
    {
        get
        {
            return false;
        }
    }

}